<?php
/*****************************************
* File      :   $RCSfile: class.widgets.foldingrow.php,v $
* Project   :   Contenido
* Descr     :   Foldable table row
* Modified  :   $Date: 2006/10/28 21:51:14 $
*
*  four for business AG, www.4fb.de
*
* $Id: class.widgets.foldingrow.php,v 1.4 2006/10/28 21:51:14 wirths Exp $
******************************************/
cInclude("classes", "contenido/class.user.php");

class cFoldingRow extends cHTML
{
	/**
	 * Table row with the header
     * @var array
     * @access private
	 */	
	var $_headerRow;
	
	/**
	 * Table header data
     * @var array
     * @access private
	 */	
	var $_headerData;	
	
	/**
	 * Table row with the content
     * @var array
     * @access private
	 */	
	var $_contentRow;
	
	/**
	 * Table content data
     * @var array
     * @access private
	 */	
	var $_contentData;
	
	
	function cFoldingRow ($uuid, $caption = "")
	{
		global $auth;
		
		$this->setCaption($caption);
		
		$this->_headerRow   = new cHTMLTableRow;
		$this->_headerData  = new cHTMLTableData;
		$this->_contentRow  = new cHTMLTableRow;
		$this->_contentData = new cHTMLTableData;
		$this->_uuid		= $uuid;
		
		$this->_link = new cHTMLLink;
		
		$this->_headerData->setClass("foldingrow");
		
		$this->_foldingImage = new cHTMLImage;
		$this->_foldingImage->setStyle("margin-right: 4px;");
		
		$this->setExpanded(false);
		
		$this->_hiddenField = new cHTMLHiddenField("expandstate_".$this->_contentRow->getID());
		
		$this->addRequiredScript("cfoldingrow.js");
		$this->addRequiredScript("parameterCollector.js");
		
		/* Check for expandstate */
		$user = new cApiUser($auth->auth["uid"]);
		
		if (!$user->virgin)
		{
			if ($user->getProperty("expandstate", $uuid) == "true")
			{
				$this->setExpanded($user->getProperty("expandstate", $uuid));	
			}
		}
		
	}
	
	function setExpanded ($expanded = false)
	{
		if ($expanded == true)
		{
			$this->_foldingImage->setSrc("images/widgets/foldingrow/expanded.gif");
			$this->_foldingImage->updateAttributes(array("data" => "expanded"));
			$this->_contentRow->setStyle("display: ;");
		} else {
			$this->_foldingImage->setSrc("images/widgets/foldingrow/collapsed.gif");
			$this->_foldingImage->updateAttributes(array("data" => "collapsed"));
			$this->_contentRow->setStyle("display: none;");
		}
		$this->_expanded = $expanded;	
	}
	
	function setCaption ($caption)
	{
		$this->_caption = $caption;	
	}
	
	function setHelpContext ($context = false)
	{
		$this->_helpContext = $context;
	}
	
	function setIndent ($indent = 0)
	{
		$this->_indent = $indent;	
	}
	
	function setContentData ($content)
	{
		$this->_contentData->setContent($content);	
	}
	
	function render ()
	{
		/* Build the expand/collapse link */
		
		$this->_link->setClass("foldingrow");
		
		$imgid = $this->_foldingImage->getID();
		$rowid = $this->_contentRow->getID();
		$hiddenid = $this->_hiddenField->getID();
		
		$uuid = $this->_uuid;
		
		$this->_link->setLink("javascript:cFoldingRow_expandCollapse('$imgid', '$rowid', '$hiddenid', '$uuid');");  
		$this->_link->setContent($this->_foldingImage->render() . $this->_caption);
		
		$this->_headerData->setContent(array($this->_hiddenField,$this->_link));
		$this->_headerRow->setContent($this->_headerData);
		
		$this->_contentRow->setContent($this->_contentData);
		
		$output  = $this->_headerRow->render();
		$output .= $this->_contentRow->render();
		
		return ($output);
	}
	
}
 
?>