<?php

class cSetupConfigMode extends cSetupMask
{
	function cSetupConfigMode ($step, $previous, $next)
	{
		if ($_SESSION["setuptype"] == "setup")
		{
			cSetupMask::cSetupMask("templates/setup/forms/configmode.tpl", $step);
		} else {
			cSetupMask::cSetupMask("templates/setup/forms/configmodewopass.tpl", $step);
		}
		$this->setHeader(i18n("config.php mode"));
		$this->_oStepTemplate->set("s", "TITLE", i18n("config.php mode"));
		$this->_oStepTemplate->set("s", "DESCRIPTION", i18n("Please choose 'save' or 'download'"));
		$this->_oStepTemplate->set("s", "LABEL_DESCRIPTION", i18n("Contenido requires a configuration file called 'config.php'. This file will be generated by the setup automatically if the filesystem permissions are correct. If 'save' is activated by default, setup can save the file config.php. If not, 'download' is activated by default, and you have to place the file in the directory &quot;contenido/includes/&quot; manually when a download prompt appears. The download prompt appears at the end of the setup process."));
		
		$oConfigSave = new cHTMLRadiobutton("configmode", "save");
		$oConfigSave->setLabelText(" ");

		$oConfigDownload = new cHTMLRadiobutton("configmode", "download");
		$oConfigDownload->setLabelText(" ");
				
		if (canWriteFile("../contenido/includes/config.php"))
		{
			$oConfigSave->setChecked(true);
		} else {
			$oConfigDownload->setChecked(true);	
		}
		

		$oConfigSaveLabel = new cHTMLLabel(i18n("Save"), $oConfigSave->getId());
		$this->_oStepTemplate->set("s", "CONTROL_SAVE", $oConfigSave->render());
		$this->_oStepTemplate->set("s", "CONTROL_SAVELABEL", $oConfigSaveLabel->render());
		
		$oConfigDownloadLabel = new cHTMLLabel(i18n("Download"), $oConfigDownload->getId());
		$this->_oStepTemplate->set("s", "CONTROL_DOWNLOAD", $oConfigDownload->render());
		$this->_oStepTemplate->set("s", "CONTROL_DOWNLOADLABEL", $oConfigDownloadLabel->render());

		$this->setNavigation($previous, $next);
	}

	function _createNavigation ()
	{
		$link = new cHTMLLink("#");
		
		if ($this->_bNextstep == "doinstall")
		{
			/* Install launcher */
		}

		$link->attachEventDefinition("pageAttach", "onclick", "document.setupform.step.value = '".$this->_bNextstep."'; document.setupform.submit();");
		
		$nextSetup = new cHTMLAlphaImage;
		$nextSetup->setSrc("images/controls/next.png");
		$nextSetup->setMouseOver("images/controls/next_over.png");
		$nextSetup->setClass("button");
		
		$link->setContent($nextSetup);
		
		$this->_oStepTemplate->set("s", "NEXT", $link->render());	
		
		$backlink = new cHTMLLink("#");
		$backlink->attachEventDefinition("pageAttach", "onclick", "document.setupform.step.value = '".$this->_bBackstep."';");
		$backlink->attachEventDefinition("submitAttach", "onclick", "document.setupform.submit();");
		
		$backSetup = new cHTMLAlphaImage;
		$backSetup->setSrc("images/controls/back.png");
		$backSetup->setMouseOver("images/controls/back_over.png");
		$backSetup->setClass("button");
		$backSetup->setStyle("padding-right: 10px");
		$backlink->setContent($backSetup);		
		$this->_oStepTemplate->set("s", "BACK", $backlink->render());
		
				
	}		
}

?>